<?php
if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Priest extends REF_Controller {
    public function __construct() {
        parent::__construct();
        $this->load->library('upload');
        $this->load->model('priest_model', '', TRUE);
        $this->uri_key_index = 0;
    }
    
    public function index() {
        $data = array();
        $data['results'] = $this->priest_model->list_all();
        if (!empty($this->session->flashdata('success'))) 
            $data['success'] = $this->session->flashdata('success');
        else 
            $data['error'] = $this->session->flashdata('error');
        
        $actions = $this->actions();
        $data['add_btn']    = 'Create New Priest';
        $data['view_link']  = $actions['view'] . '/';
        $data['add_link']   = $actions['add'];
        $data['edit_link']  = $actions['edit'] . '/';
        $data['delete_link']= $actions['delete'] . '/';
        
        $service_menu_id = get_master_controller_id($actions['controller']);
        $data['service_menu_id'] = array('service_menu_id' => $service_menu_id, 'menu_type' => '1');
        $this->render($data, 'priest/list');
    }
    
    private function get_priest_url_key($name, $id = '') {
        $url_key = get_url_key($name);
        if ($this->priest_model->priest_url_key_exists($url_key, $id)) {
            $this->uri_key_index ++;
            return $this->get_priest_url_key($name . '_' . $this->uri_key_index, $id);
        }
        
        return $url_key;
    }
    
    public function add() {
        $data = array();
        $actions = $this->actions();
        $data['form_action'] = $actions['insert'];
        $this->render($data, 'priest/add');
    }
    
    public function insert() {
        $insert = array(
            'name' => $this->input->post('name'),
            'designation' => $this->input->post('designation'),
            'url_key' => $this->get_priest_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'created_by' => $this->user_data['user_id'],
            'created_on' => date('Y-m-d H:i:s')
        );
        
        $insert_id = $this->priest_model->insert($insert);  
        if ($insert_id > 0)
            $this->session->set_flashdata('success', 'Priest details added successfully');    
        
        else
            $this->session->set_flashdata('error', 'Priest details not added!');
        redirect('priest', 'refresh');
    }
    
    public function edit($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['priest'] = $this->priest_model->get_by_id($id);
        $actions = $this->actions();
        $data['form_action'] = $actions['update'] . '/' . $id;
        $this->render($data, 'priest/edit');
    }
    
    public function update($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array(
            'name' => $this->input->post('name'),
            'designation' => $this->input->post('designation'),
            'url_key' => $this->get_priest_url_key($this->input->post('name')),
            'status' => $this->input->post('status'),
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        
        if ( $this->priest_model->update($update, $id) > 0)
            $this->session->set_flashdata('success', 'Priest details updated successfully');  
       
        else
            $this->session->set_flashdata('error', 'Priest details not updated!');    
        
        redirect('priest','refresh');
    }
    
    public function view($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $data = array();
        $data['priest'] = $this->priest_model->get_by_id($id);
        $this->render($data, 'priest/view');
    }
    
    public function delete($id = '') {
        if (empty($id)) {
            show_400_error();
        }
        
        $update = array ( 
            'status' => 2,
            'updated_by' => $this->user_data['user_id'],
            'updated_on' => date('Y-m-d H:i:s')
        );
        
        if ($this->priest_model->update($update,$id) > 0)
            $this->session->set_flashdata('success', 'Priest details deleted successfully');
            
        else 
            $this->session->set_flashdata('error', 'Priest details not deleted!');
        
        redirect( 'priest', 'refresh');
    }
    
    public function priest_name_exists() {
        $data = $this->priest_model->priest_name_exists($_POST['name'],$_POST['designation'],$_POST['id']);
        echo json_encode($data);
        exit(0);
    }
}
?>